tef/urls.py
from django.conf.urls import url
from . import views

app_name = 'tef'
urlpatterns = [
    url(r'^$', views.search, name='search'),
    url(r'^review/(?P<te_id>[0-9]+)/$', views.review, name='review')
]

tefinder/urls.py
from django.conf.urls import include, url

urlpatterns = [
    url(r'^', include('tef.urls')),
]

tef/models.py
from django.db import models
from django.contrib.auth.models import User


# Create your models here.
class TE(models.Model):
    user = models.ForeignKey(User,
                             on_delete=models.CASCADE,
                             null=True,
                             blank=False)
    query = models.TextField(blank=False)
    reverse_query = models.TextField(null=True, blank=True)
    threshold = models.IntegerField(default=0)
    query_date = models.DateTimeField(auto_now_add=True)
    solved = models.BooleanField(default=False)
    distance = models.IntegerField(default=0)

    def __str__(self):
        return self.query


class Solution(models.Model):
    te = models.ForeignKey(TE,
                           on_delete=models.CASCADE)
    solution = models.TextField(null=True, blank=False)
    percentage = models.DecimalField(max_digits=3, decimal_places=1)
    distance = models.IntegerField(null=False, blank=False)

    def __str__(self):
        return str(self.percentage)

tef/forms.py
from django import forms
import re


class SearchForm(forms.Form):
    query = forms.RegexField(
        r'>(.)*\n([ACTGactg\r\n]*)$',
        label='FASTA Sequence',
        widget=forms.Textarea
    )
    threshold = forms.IntegerField(
        label='Threshold',
        min_value=1,
        initial=60
    )
    distance = forms.IntegerField(
        label='Distance',
        min_value=1,
        initial=50
    )

    def clean_query(self):
        data = self.cleaned_data['query']
        data = re.sub(r'>(.)*\n', '', data)
        data = re.sub(r'(\r\n)*', '', data)
        return data.upper()

    def clean(self):
        cleaned_data = super(SearchForm, self).clean()

tef/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import render, get_object_or_404
from django.core.urlresolvers import reverse
import json
from .forms import SearchForm
from .tasks import queue_te
from .models import TE, Solution


# Shows search page
def search(request):

    if request.method == 'POST':
        form = SearchForm(request.POST)

        if form.is_valid():
            # Create original object
            t = TE(
                query=form.cleaned_data['query'],
                threshold=form.cleaned_data['threshold'],
                distance=form.cleaned_data['distance']
            )
            t.save()

            # Throw into celery
            queue_te(t.id)

            return HttpResponseRedirect(reverse('tef:review', args=(t.id,)))
        else:
            context = {'search_form': form}
            return render(request, 'tef/index.html', context)
    else:
        context = {
            'search_form': SearchForm(),
            'title': 'Search'
        }
        return render(request, 'tef/index.html', context)


def review(request, te_id):
    te = get_object_or_404(TE, pk=te_id)

    if te.solved:
        solved = True

    soln = Solution.objects.filter(te=te_id).order_by('-percentage')

    context = {
        'te': te,
        'solved': solved,
        'soln': soln,
        'soln_count': soln.count(),
        'title': 'Review'
    }

    return render(request, 'tef/review.html', context)

tef/templates/tef/forms/form_template.html
{% csrf_token %}
{% for field in form %}
    <div class="field">
        {% if field.errors %}
            <div class="ui red message">
                {{ field.errors }}
            </div>
        {% endif %}
        {{ field.label_tag }} {{ field }}
    </div>
{% endfor %}
<input type="submit" class="ui fluid teal submit button" value="Submit" />

tef/templates/tef/index.html
{% include "tef/layout/header.html" with title=title %}
<div class="ui middle aligned grid">
    <div class="column">
        <form action="{% url 'tef:search' %}" method="post" class="ui large form">
            <div class="ui stacked segment">
                <h2 class="ui teal header">Sequence Search</h2>
                <div class="ui message">
                    <div class="header">How to Use</div>
                    <p>Use the TEFinder to find transposons in your DNA sequence. Simply
                    enter your FASTA sequence in box below and hit enter.</p>
                    <ul class="list">
                        <li>
                            Threshold and Distance allow you to control how precise the search is.
                            <ul class="list">
                                <li>Threshold is the percentage of matches you would like over the distance specified.</li>
                                <li>Distance is the minimum total distance that we should consider a threshold for.</li>
                                <li>For example, 33 matches over a distance of 50 bases would be caught with a maximum of 66% threshold.</li>
                            </ul>
                        </li>
                    </ul>
                </div>
                <div class="ui divider"></div>
                {% include "tef/forms/form_template.html" with form=search_form %}
            </div>
        </form>
    </div>
</div>
{% include "tef/layout/footer.html" %}

tef/templates/tef/layout/footer.html
</div>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.0/jquery.min.js"></script>
<script type="text/javascript" src="//oss.maxcdn.com/semantic-ui/2.1.8/semantic.min.js"></script>
</body>
</html>

tef/templates/tef/layout/header.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>TEFinder | {{ title }}</title>
    {% load staticfiles %}
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" class="ui" href="//oss.maxcdn.com/semantic-ui/2.1.8/semantic.min.css">
    <link rel="stylesheet" type="text/css" href="{% static 'tef/main.css' %}">
</head>
<body>
    <div class="ui fixed inverted menu">
        <div class="ui container">
            <a href="{% url 'tef:search' %}" class="header item">
                <i class="fa fa-code fa-2x"></i>&nbsp; TEFinder
            </a>
        </div>
    </div>
    <div class="ui main container">
        <h1 class="ui header"></h1>

tef/templates/tef/review.html
{% include "tef/layout/header.html" with title=title%}
<div class="ui middle aligned grid">
    <div class="column">
        <div class="ui stacked segment">
            <h2 class="ui teal header">Search Analysis</h2>
            <div class="ui divider"></div>
            {% if te.solved == False %}
                <div class="ui icon message">
                    <i class="notched circle loading icon"></i>
                    <div class="content">
                    <div class="header">
                        Search Queued
                    </div>
                    <p>Your search is on the queue for completion. Please check back shortly for your results</p>
                  </div>
                </div>
            {% else %}
                <table class="ui celled table courier">
                    <thead>
                        <tr>
                            <th>Sequence</th>
                            <th>Percentage</th>
                            <th>Distance</th>
                        </tr>
                    </thead>
                    <tbody>
                    {% if soln_count == 0 %}
                        <div class="ui info message">
                            <div class="ui header">No matches found</div>
                            <p>We're sorry, but no matches could be found. Try revising your search</p>
                        </div>
                    {% else %}
                        {% for sol in soln %}
                            <tr>
                                <td>
                                    {{ sol.solution | linebreaks }}
                                </td>
                                <td>
                                    {{ sol.percentage }}
                                </td>
                                <td>
                                    {{ sol.distance }}
                                </td>
                            </tr>
                        {% endfor %}
                    {% endif %}
                    </tbody>
                </table>
            {% endif %}
        </div>
    </div>
</div>

{% include "tef/layout/footer.html" %}